using System.Collections.Generic;
using System.Linq;
using WalkingTec.Mvvm.Core;
using WalkingTec.Mvvm.Core.Extensions;

namespace WalkingTec.Mvvm.Demo.ViewModels.HomeVMs
{
    public class IndexVM : BaseVM
    {
        public List<FrameworkMenu> AllMenu { get; set; }

        public List<TreeSelectListItem> Menu
        {
            get
            {
                return GetUserMenu();
            }
        }

        public List<TreeSelectListItem> GetUserMenu()
        {
            if (ConfigInfo.IsQuickDebug == true)
            {
                return AllMenu.AsQueryable().GetTreeSelectListItems(null, null, x => x.PageName, null, x => x.IConId.ToString(), x => x.Url, SortByName: false); ;
            }
            else
            {
                var rv = AllMenu.Where(x =>x.ShowOnMenu == true).AsQueryable().GetTreeSelectListItems(null, null, x => x.PageName, null, x => x.IConId.ToString(), x => x.Url, SortByName: false);
                RemoveUnAccessableMenu(rv, LoginUserInfo);
                RemoveEmptyMenu(rv);
                return rv;
            }
        }

        /// <summary>
        /// ƳûȨ޷ʵĲ˵
        /// </summary>
        /// <param name="menus">˵б</param>
        /// <param name="info">ûϢ</param>
        private void RemoveUnAccessableMenu(List<TreeSelectListItem> menus, LoginUserInfo info)
        {
            if (menus == null)
            {
                return;
            }

            List<TreeSelectListItem> toRemove = new List<TreeSelectListItem>();
            //ûָûϢõǰûĵ¼Ϣ
            if (info == null)
            {
                info = LoginUserInfo;
            }
            //ѭв˵
            foreach (var menu in menus)
            {
                //жǷȨޣûУӵҪƳб
                if (!string.IsNullOrEmpty(menu.Url) && info.IsAccessable(menu.Url) == false)
                {
                    toRemove.Add(menu);
                }
                //ȨޣݹñӲ˵
                else
                {
                    RemoveUnAccessableMenu(menu.Children, info);
                }
            }
            //ɾûȨ޷ʵĲ˵
            foreach (var remove in toRemove)
            {
                menus.Remove(remove);
            }
        }

        private void RemoveEmptyMenu(List<TreeSelectListItem> menus)
        {
            for(int i = 0; i < menus.Count; i++)
            {
                if(menus[i].Children == null || menus[i].Children.Count == 0)
                {
                    menus.RemoveAt(i);
                    i--;
                }
            }

        }

    }
}
